import tkinter as tk
from tkinter import messagebox
from warehouse_gui import WarehouseGUI  # 假设这是仓库管理系统的GUI类


class LoginGUI:
    def __init__(self, master):
        self.master = master
        master.title("登录界面")

        self.username_label = tk.Label(master, text="用户名:")
        self.username_label.pack()
        self.username_entry = tk.Entry(master)
        self.username_entry.pack()

        self.password_label = tk.Label(master, text="密码:")
        self.password_label.pack()
        self.password_entry = tk.Entry(master, show="*")
        self.password_entry.pack()

        self.login_button = tk.Button(master, text="登录", command=self.validate_login)
        self.login_button.pack()

    def validate_login(self):
        username = self.username_entry.get()
        password = self.password_entry.get()

        # 这里应该有一个验证用户名和密码的逻辑，比如查询数据库
        # 为了简化，这里直接使用硬编码的用户名和密码做示例
        valid_username = "admin"
        valid_password = "123456"

        if username == valid_username and password == valid_password:
            messagebox.showinfo("登录成功", "欢迎，管理员！")
            self.master.destroy()  # 销毁登录界面
            self.start_warehouse_app()  # 启动仓库管理系统界面
        else:
            messagebox.showerror("登录失败", "用户名或密码错误！")



    def start_warehouse_app(self):
        root = tk.Tk()
        WarehouseGUI(root)  # 假设WarehouseGUI是仓库管理系统的主界面类
        root.mainloop()


if __name__ == "__main__":
    login_root = tk.Tk()
    LoginGUI(login_root)
    login_root.mainloop()